"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.container = void 0;
require("reflect-metadata");
class Container {
    constructor() {
        this._availableInstances = [];
    }
    static get Instance() {
        if (!Container._containerInstance)
            Container._containerInstance = new Container();
        return Container._containerInstance;
    }
    getAvailableInstances() {
        return this._availableInstances;
    }
    resolveInstance(Resource) {
        const available = this._availableInstances.find(instance => instance.constructor.name === Resource.name);
        if (available)
            return available;
        const dependencies = Reflect.getMetadata("design:paramtypes", Resource) || [];
        const instances = [];
        for (const dependency of dependencies) {
            instances.push(this.resolveInstance(dependency));
        }
        const acquiredResource = new Resource(...instances);
        this._availableInstances.push(acquiredResource);
        return acquiredResource;
    }
}
Container._containerInstance = null;
exports.container = Container.Instance;
//# sourceMappingURL=Container.js.map