import "reflect-metadata";
import { ApplicationOptions } from "../../interfaces/ApplicationOptions";
import { ObjectConstructor } from "../../types";
/**
 * @param ApplicationOptions: {   appHandler?: Application; port?: number; verbose?: "no" | "minimal" | "detailed"; controllers: Function[]; }
 *
 * * Initialize application with controllers.
 * * A new instance of app is created by default, but a pre-configured instance of express application can be used.
 * * Using the verbose option logs controller and route details to the console.
 */
export declare function ApplicationServer({ controllers, port, appHandler, verbose }: ApplicationOptions): (Constructor: ObjectConstructor<any>) => void;
