"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DELETE = exports.PUT = exports.POST = exports.GET = void 0;
require("reflect-metadata");
const buildMethodDecorator_1 = require("../factories/buildMethodDecorator");
/**
 *
 * @param route: string
 * * Use the decorated method as a handler for GET requests to the route.
 */
function GET(route) {
    return buildMethodDecorator_1.buildMethodDecorator("get", route);
}
exports.GET = GET;
/**
 *
 * @param route: string
 * * Use the decorated method as a handler for POST requests to the route.
 */
function POST(route) {
    return buildMethodDecorator_1.buildMethodDecorator("post", route);
}
exports.POST = POST;
/**
 *
 * @param route: string
 * * Use the decorated method as a handler for PUT requests to the route.
 */
function PUT(route) {
    return buildMethodDecorator_1.buildMethodDecorator("put", route);
}
exports.PUT = PUT;
/**
 *
 * @param route: string
 * * Use the decorated method as a handler for DELETE requests to the route.
 */
function DELETE(route) {
    return buildMethodDecorator_1.buildMethodDecorator("delete", route);
}
exports.DELETE = DELETE;
//# sourceMappingURL=ControllerMethods.js.map