"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.handleControllerRequestEntry = void 0;
require("reflect-metadata");
const functionCheck_1 = require("../../utils/functionCheck");
function handleControllerRequestEntry(middlewares, constructor) {
    if (!functionCheck_1.isFunctionTypeOnly(middlewares))
        throw new Error("Only functions are to be passed in for handlers");
    const target = constructor.prototype;
    const controllerMetadata = Reflect.getMetadata("controller:metadata", target);
    if (controllerMetadata) {
        const updatedMetadata = Object.assign(Object.assign({}, controllerMetadata), { entryHandlers: [...(Array.isArray(middlewares) ? middlewares : [middlewares])] });
        Reflect.defineMetadata("controller:metadata", updatedMetadata, target);
    }
    else {
        Reflect.defineMetadata("controller-middleware", [].concat(middlewares), target);
    }
}
exports.handleControllerRequestEntry = handleControllerRequestEntry;
//# sourceMappingURL=controllerEntry.js.map