"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MinLength = void 0;
function MinLength(constraint) {
    return function (target, key) {
        const prevDtoConstraints = Reflect.getMetadata("dto:validation", target);
        const prevArgConstraints = prevDtoConstraints ? prevDtoConstraints[key] : undefined;
        if (prevArgConstraints === null || prevArgConstraints === void 0 ? void 0 : prevArgConstraints.maxLength)
            return;
        const paramConstraints = Object.assign(Object.assign({}, (prevArgConstraints || {})), { minLength: constraint, name: key, type: Reflect.getMetadata("design:type", target, key).name });
        const updatedMetadata = Object.assign(Object.assign({}, (Reflect.getMetadata("dto:validation", target) || {})), { [key]: paramConstraints });
        Reflect.defineMetadata("dto:validation", updatedMetadata, target);
    };
}
exports.MinLength = MinLength;
//# sourceMappingURL=MinLength.js.map