"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var TestDecorators_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.TestDecorators = void 0;
const express_1 = __importDefault(require("express"));
const _1 = require(".");
const Component_1 = require("./decorators/common/Component");
const Req_1 = require("./decorators/handler-param/Req");
const Res_1 = require("./decorators/handler-param/Res");
const MinLength_1 = require("./decorators/validation/MinLength");
function midMan(_, __, next) {
    console.log("this is the man in the middle");
    return next();
}
function secondMidMan(_, __, next) {
    console.log("second mid man");
    return next();
}
function preHandler(_, __, next) {
    console.log("preHandler hit!!!");
    return next();
}
function postHandler(_, __, next) {
    console.log("postHandler hit!!!");
    next();
}
function factory(_, ___, __) {
    console.log("hit");
    // res.send("Factory route");
}
let ServiceDep = class ServiceDep {
    dep() {
        return "dependency of dependencies";
    }
};
ServiceDep = __decorate([
    Component_1.Component()
], ServiceDep);
let Service = class Service {
    constructor(_serviceDep) {
        this._serviceDep = _serviceDep;
    }
    serviceMethod() {
        return "service called" + this._serviceDep.dep();
    }
};
Service = __decorate([
    Component_1.Component(),
    __metadata("design:paramtypes", [ServiceDep])
], Service);
let AnotherService = class AnotherService {
    anotherServiceMethod() {
        return "anotherService called";
    }
};
AnotherService = __decorate([
    Component_1.Component()
], AnotherService);
let MoreEndpoints = class MoreEndpoints {
    constructor(_service, _anotherService) {
        this._service = _service;
        this._anotherService = _anotherService;
    }
    index(res, req) {
        return __awaiter(this, void 0, void 0, function* () {
            // await new Promise((resolve, reject) => {
            //    setTimeout(() => {
            //       reject(new Error("unwanted error"));
            //    }, 1000);
            // });
            console.log(req.url);
            return res.send("Res decorator");
            // return {
            //    status: "super okay",
            //    data: "no data for you",
            // };
        });
    }
    sayHello(req, res) {
        // res.send(`${this._service.serviceMethod()} ${this._anotherService.anotherServiceMethod()}`);
        return this._service.serviceMethod() + " " + this._anotherService.anotherServiceMethod();
    }
    error(error, req, res, next) {
        console.log("controller-specific error handler");
        res.send("controller-specific error caught");
    }
};
__decorate([
    _1.GET("/v2"),
    __param(0, Res_1.Res()),
    __param(1, Req_1.Req()),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", Promise)
], MoreEndpoints.prototype, "index", null);
__decorate([
    _1.GET("/private"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", void 0)
], MoreEndpoints.prototype, "sayHello", null);
__decorate([
    _1.ErrorHandler,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Function]),
    __metadata("design:returntype", void 0)
], MoreEndpoints.prototype, "error", null);
MoreEndpoints = __decorate([
    _1.RestController("/"),
    _1.OnRequestEntry(secondMidMan),
    __metadata("design:paramtypes", [Service, AnotherService])
], MoreEndpoints);
class BodyDto {
    method() { }
}
__decorate([
    _1.Required(),
    _1.Strict(),
    MinLength_1.MinLength(5),
    __metadata("design:type", String)
], BodyDto.prototype, "name", void 0);
__decorate([
    _1.Required(),
    _1.Strict(),
    __metadata("design:type", Array)
], BodyDto.prototype, "id", void 0);
let TestDecorators = TestDecorators_1 = class TestDecorators {
    method1(_, __) {
        throw new Error("Error handler where you at");
        // return res.send("home page");
    }
    method2(ctx, q) {
        console.log(q);
        ctx.next();
        return ["ada"];
    }
    method3(app) {
        return __awaiter(this, void 0, void 0, function* () {
            console.log("DB connection, perhaps...");
            app.use(express_1.default.json());
            yield new Promise((resolve, _) => setTimeout(() => resolve("yes...")));
            app.get("/secret", (_, res) => res.send("Secret"));
            app.get("/another-secret", (_, res) => res.send("Secret"));
        });
    }
    serverHealthCheck() {
        console.log("server started");
    }
    method4() {
        return [factory];
    }
    method5(_, res) {
        console.log("post method");
        res.json({ status: "ok" });
    }
    postCheck(query, reqBody, params) {
        console.log("body through reqbody", reqBody);
        console.log("params", params);
        console.log("query", query);
        return "done";
    }
    errorHandler(error, _, res, __) {
        res.json({ status: "error", error: error.message });
    }
    catchAll(_, res) {
        res.send("Not found");
    }
};
__decorate([
    _1.OnRequestEntry(preHandler),
    _1.GET("/home"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "method1", null);
__decorate([
    _1.GET("/about"),
    _1.OnRequestEntry(preHandler),
    _1.OnRequestExit(postHandler),
    __param(0, _1.Context()),
    __param(1, _1.Query("aboutwhat")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, String]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "method2", null);
__decorate([
    _1.OnServerInit,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Function]),
    __metadata("design:returntype", Promise)
], TestDecorators.prototype, "method3", null);
__decorate([
    _1.OnServerStartup,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "serverHealthCheck", null);
__decorate([
    _1.OnRequestEntry(preHandler),
    _1.GET("/factory"),
    _1.Factory,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", []),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "method4", null);
__decorate([
    _1.OnRequestExit([postHandler]),
    _1.POST("/check"),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "method5", null);
__decorate([
    _1.POST("/data/:id"),
    __param(0, _1.Query("q")),
    __param(1, _1.Body()),
    __param(2, _1.Params("id")),
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, BodyDto, Object]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "postCheck", null);
__decorate([
    _1.ErrorHandler,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object, Object, Function]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "errorHandler", null);
__decorate([
    _1.WildcardHandler,
    __metadata("design:type", Function),
    __metadata("design:paramtypes", [Object, Object]),
    __metadata("design:returntype", void 0)
], TestDecorators.prototype, "catchAll", null);
TestDecorators = TestDecorators_1 = __decorate([
    _1.ApplicationServer({
        port: 5000,
        verbose: "minimal",
        controllers: [MoreEndpoints, TestDecorators_1],
    }),
    _1.OnRequestEntry(midMan),
    _1.OnRequestExit(factory),
    _1.RestController("/api")
], TestDecorators);
exports.TestDecorators = TestDecorators;
//# sourceMappingURL=sample.js.map