"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.pathMap = exports.PathMap = void 0;
class PathMap {
    constructor() {
        this._pathList = [];
        this.printRouteMap = this.printRouteMap.bind(this);
        this.split = this.split.bind(this);
    }
    static get Instance() {
        if (!this._pathMapInstance)
            this._pathMapInstance = new PathMap();
        return this._pathMapInstance;
    }
    displayDetailedPathMap(controllerModels) {
        for (const model of controllerModels) {
            console.log(`Controller Name =>> ${model.controllerName}\n`);
            console.log("Entry Middleware_____________________", model.entryMiddleware);
            console.table(model.endPoints);
            console.log("Exit Middleware_____________________", model.exitMiddleware, "\n\n");
            console.log(`-----End of Controller-----\n`);
        }
    }
    displayPathMap(app) {
        var _a;
        (_a = app._router) === null || _a === void 0 ? void 0 : _a.stack.forEach(this.printRouteMap.bind(null, []));
        console.table(this._pathList);
        this._pathList.length = 0;
    }
    printRouteMap(path, layer) {
        if (layer.route) {
            layer.route.stack.forEach(this.printRouteMap.bind(null, path.concat(this.split(layer.route.path))));
        }
        else if (layer.name === "router" && layer.handle.stack) {
            layer.handle.stack.forEach(this.printRouteMap.bind(null, path.concat(this.split(layer.regexp))));
        }
        else if (layer.method) {
            return this._pathList.push({
                route: "/" + path.concat(this.split(layer.regexp)).filter(Boolean).join("/"),
                handler: layer.name,
                method: layer.method.toUpperCase(),
            });
        }
    }
    split(thing) {
        if (typeof thing === "string") {
            return thing.split("/");
        }
        else if (thing.fast_slash) {
            return "";
        }
        else {
            let match = thing
                .toString()
                .replace("\\/?", "")
                .replace("(?=\\/|$)", "$")
                .match(/^\/\^((?:\\[.*+?^${}()|[\]\\\/]|[^.*+?^${}()|[\]\\\/])*)\$\//);
            return match ? match[1].replace(/\\(.)/g, "$1").split("/") : "<complex:" + thing.toString() + ">";
        }
    }
}
exports.PathMap = PathMap;
PathMap._pathMapInstance = null;
exports.pathMap = PathMap.Instance;
//Credits to Douglas Wilson, member of express.js, for the route-search code
//https://github.com/dougwilson?tab=repositories
//# sourceMappingURL=printRoutes.js.map